Subject: Re: [GSoC 11 submodule] Status update

From: Phil Hord <[email-masked]>
Date: Thu, 30 Jun 2011 13:54:19 -0400

On 06/29/2011 05:58 PM, Junio C Hamano wrote:
> Phil Hord <[email-masked]> writes:
>> It frightens me because it seems like a fundamental break from the
>> current submodule functionality.  Today a submodule exists as a git
>> repository with no knowledge that it is a submodule or who its
>> super-repository is.
> The use of .git that is a text file that records where the real directory
> is not limited to submodules.  Placing that "real directory" somewhere in
> the .git directory of the superproject is merely a convention.
>
> In other words, it does not change anything fundamental.

Thanks for pointing that out.  I was unaware of that feature until I saw
it discussed in another thread this week.  Even then, it was not clear
to me that this is the same feature being employed here.

> When switching to another branch, a directory that does not exist in the
> switched-to branch needs to be removed, but we would refrain from "rm -fr"
> that directory if it has any leftover cruft in it (untracked and unignored
> files). A submodule directory should behave in the same way.

Thanks.  I am suitably enclued and no longer afraid.

Phil